Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# Lamp::Bone Class Reference

ボーン More...

`#include <Bone.h>`

List of all members.

## Public Member Functions
virtual const Matrix34 & | getLocalMatrix ()
| ローカル行列の取得
virtual const Matrix34 & | getModelMatrix ()
| モデル行列の取得
virtual const Matrix34 & | getDeformMatrix ()
| 変形行列の取得
virtual void | setInversePoseMatrix (const Matrix34 &inversePoseMatrix)
| ポーズ逆行列の設定
virtual const Matrix34 & | getInversePoseMatrix () const
| ポーズ逆行列の取得
virtual void | setScale (const Vector3 &scale)
| スケールの設定
virtual const Vector3 & | getScale () const
| スケールの取得
virtual bool | isScaled () const
| スケールを使用しているか
virtual void | setRotationXYZ (const Vector3 &rotation)
| XYZ回転の設定.
virtual const Vector3 & | getRotationXYZ ()
| XYZ回転の取得.
virtual void | setRotationQuaternion (const Quaternion &rotation)
| 四元数回転の設定
virtual const Quaternion & | getRotationQuaternion ()
| 四元数回転の取得
virtual void | setTranslation (const Vector3 &translation)
| 移動の設定
virtual const Vector3 & | getTranslation () const
| 移動の取得
virtual void | addBone (Bone *bone)
| ボーンの追加
virtual void | removeBone (Bone *bone)
| ボーンの削除
virtual int | getBoneCount () const
| ボーン数の取得
virtual Bone * | getBone (int index) const
| ボーンの取得
virtual const String & | getName () const
| 名前の取得
virtual void | copyBoneValue (Bone *destination) const
| ボーンの値コピー
## Protected Member Functions
| Bone (const String &name)
| コンストラクタ
virtual | ~Bone ()
| デストラクタ
virtual bool | buildBoneMatrix (const Matrix34 &parentModelMatrix)
| ボーン行列の構築
## Protected Attributes
Axis3 | axis_
| 軸
Matrix34 | inversePoseMatrix_
| ポーズ逆行列
Matrix34 | modelMatrix_
| モデル行列
Matrix34 | deformMatrix_
| 変形行列
ArrayList< Bone * > | bones_
| ボーン配列
String | name_
| 名前
## Friends
class | CharacterModel

## Detailed Description

ボーン

Definition at line 37 of file Bone.h.

## Constructor & Destructor Documentation

Lamp::Bone::Bone | ( | const String & | name | ) | `[protected]`

  | コンストラクタ Parameters:
  name | 名前
Definition at line 32 of file Bone.cpp.

## Member Function Documentation

virtual void Lamp::Bone::addBone | ( | Bone * | bone | ) | `[inline, virtual]`

  | ボーンの追加 Parameters:
  bone | 追加するボーン
Definition at line 153 of file Bone.h. References Lamp::ArrayList< Bone * >::add(), and bones_. Referenced by Lamp::CharacterModel::copyCharacterModel(), Lamp::TextSceneLoader::readCharacterModel(), and Lamp::BinarySceneLoader::readCharacterModel().

bool Lamp::Bone::buildBoneMatrix | ( | const Matrix34 & | parentModelMatrix | ) | `[protected, virtual]`

  | ボーン行列の構築 Parameters:
  parentModelMatrix | 親のモデル行列
Returns: スケールが含まれていればtrue Definition at line 47 of file Bone.cpp. References axis_, Lamp::Axis3::buildMatrix(), deformMatrix_, getBone(), getBoneCount(), getLocalMatrix(), inversePoseMatrix_, Lamp::Axis3::isScaled(), and modelMatrix_. Referenced by Lamp::CharacterModel::buildBoneMatrix().

void Lamp::Bone::copyBoneValue | ( | Bone * | destination | ) | const`[virtual]`

  | ボーンの値コピー Parameters:
  destination | コピー先ボーン
Definition at line 41 of file Bone.cpp. References axis_, getInversePoseMatrix(), and setInversePoseMatrix(). Referenced by Lamp::CharacterModel::copyCharacterModel().

virtual Bone* Lamp::Bone::getBone | ( | int | index | ) | const`[inline, virtual]`

  | ボーンの取得 Parameters:
  index | インデックス
Returns: ボーン Definition at line 176 of file Bone.h. References Assert, bones_, Lamp::ArrayList< Bone * >::get(), and getBoneCount(). Referenced by Lamp::PrimitiveDrawRequestBuilder::buildBone(), buildBoneMatrix(), Lamp::CharacterModel::copyCharacterModel(), Lamp::TextSceneSaver::writeBoneLink(), and Lamp::BinarySceneSaver::writeBoneLink().

virtual int Lamp::Bone::getBoneCount | ( |  | ) | const`[inline, virtual]`

| ボーン数の取得 Returns: ボーン数 Definition at line 169 of file Bone.h. References bones_, and Lamp::ArrayList< Bone * >::getCount(). Referenced by Lamp::PrimitiveDrawRequestBuilder::buildBone(), buildBoneMatrix(), Lamp::CharacterModel::copyCharacterModel(), getBone(), Lamp::TextSceneSaver::writeBoneLink(), and Lamp::BinarySceneSaver::writeBoneLink().

virtual const Matrix34& Lamp::Bone::getDeformMatrix | ( |  | ) | `[inline, virtual]`

| 変形行列の取得 Returns: 変形行列 Definition at line 57 of file Bone.h. References deformMatrix_. Referenced by Lamp::PrimitiveDrawRequestBuilder::buildBone(), and Lamp::CharacterModel::buildDeformMatrixArray().

virtual const Matrix34& Lamp::Bone::getInversePoseMatrix | ( |  | ) | const`[inline, virtual]`

| ポーズ逆行列の取得 Returns: ポーズ逆行列 Definition at line 72 of file Bone.h. References inversePoseMatrix_. Referenced by Lamp::PrimitiveDrawRequestBuilder::buildBone(), copyBoneValue(), Lamp::TextSceneSaver::writeBone(), and Lamp::BinarySceneSaver::writeBone().

virtual const Matrix34& Lamp::Bone::getLocalMatrix | ( |  | ) | `[inline, virtual]`

| ローカル行列の取得 Returns: ローカル行列 Definition at line 45 of file Bone.h. References axis_, and Lamp::Axis3::getMatrix(). Referenced by buildBoneMatrix().

virtual const Matrix34& Lamp::Bone::getModelMatrix | ( |  | ) | `[inline, virtual]`

| モデル行列の取得 Returns: モデル行列 Definition at line 51 of file Bone.h. References modelMatrix_.

virtual const String& Lamp::Bone::getName | ( |  | ) | const`[inline, virtual]`

| 名前の取得 Returns: 名前 Definition at line 187 of file Bone.h. References name_. Referenced by Lamp::CharacterModel::copyCharacterModel(), Lamp::CharacterModel::destroyBone(), Lamp::TextSceneSaver::writeBone(), Lamp::BinarySceneSaver::writeBone(), and Lamp::TextSceneSaver::writeBoneLink().

virtual const Quaternion& Lamp::Bone::getRotationQuaternion | ( |  | ) | `[inline, virtual]`

| 四元数回転の取得 Returns: 四元数回転 Definition at line 125 of file Bone.h. References axis_, and Lamp::Axis3::getRotationQuaternion().

virtual const Vector3& Lamp::Bone::getRotationXYZ | ( |  | ) | `[inline, virtual]`

| XYZ回転の取得. Returns: XYZ回転 Definition at line 108 of file Bone.h. References axis_, and Lamp::Axis3::getRotationXYZ(). Referenced by Lamp::TextSceneSaver::writeBone(), and Lamp::BinarySceneSaver::writeBone().

virtual const Vector3& Lamp::Bone::getScale | ( |  | ) | const`[inline, virtual]`

| スケールの取得 Returns: スケール Definition at line 87 of file Bone.h. References axis_, and Lamp::Axis3::getScale(). Referenced by Lamp::TextSceneSaver::writeBone(), and Lamp::BinarySceneSaver::writeBone().

virtual const Vector3& Lamp::Bone::getTranslation | ( |  | ) | const`[inline, virtual]`

| 移動の取得 Returns: 移動 Definition at line 142 of file Bone.h. References axis_, and Lamp::Axis3::getTranslation(). Referenced by Lamp::TextSceneSaver::writeBone(), and Lamp::BinarySceneSaver::writeBone().

virtual bool Lamp::Bone::isScaled | ( |  | ) | const`[inline, virtual]`

| スケールを使用しているか Returns: スケールを使用しているならtrue Definition at line 93 of file Bone.h. References axis_, and Lamp::Axis3::isScaled().

virtual void Lamp::Bone::removeBone | ( | Bone * | bone | ) | `[inline, virtual]`

  | ボーンの削除 Parameters:
  bone | 削除するボーン
Definition at line 161 of file Bone.h. References bones_, and Lamp::ArrayList< Bone * >::removeByValue().

virtual void Lamp::Bone::setInversePoseMatrix | ( | const Matrix34 & | inversePoseMatrix | ) | `[inline, virtual]`

  | ポーズ逆行列の設定 Parameters:
  inversePoseMatrix | ポーズ逆行列
Definition at line 64 of file Bone.h. References inversePoseMatrix_. Referenced by copyBoneValue(), Lamp::TextSceneLoader::readBone(), and Lamp::BinarySceneLoader::readBone().

virtual void Lamp::Bone::setRotationQuaternion | ( | const Quaternion & | rotation | ) | `[inline, virtual]`

  | 四元数回転の設定 Parameters:
  rotation | 四元数回転
Definition at line 117 of file Bone.h. References axis_, and Lamp::Axis3::setRotationQuaternion(). Referenced by Lamp::CharacterModelAnimation::animate().

virtual void Lamp::Bone::setRotationXYZ | ( | const Vector3 & | rotation | ) | `[inline, virtual]`

  | XYZ回転の設定. Parameters:
  rotation | XYZ回転
Definition at line 100 of file Bone.h. References axis_, and Lamp::Axis3::setRotationXYZ(). Referenced by Lamp::CharacterModelAnimation::animate(), Lamp::TextSceneLoader::readBone(), and Lamp::BinarySceneLoader::readBone().

virtual void Lamp::Bone::setScale | ( | const Vector3 & | scale | ) | `[inline, virtual]`

  | スケールの設定 Parameters:
  scale | スケール
Definition at line 81 of file Bone.h. References axis_, and Lamp::Axis3::setScale(). Referenced by Lamp::CharacterModelAnimation::animate(), Lamp::TextSceneLoader::readBone(), and Lamp::BinarySceneLoader::readBone().

virtual void Lamp::Bone::setTranslation | ( | const Vector3 & | translation | ) | `[inline, virtual]`

  | 移動の設定 Parameters:
  translation | 移動
Definition at line 134 of file Bone.h. References axis_, and Lamp::Axis3::setTranslation(). Referenced by Lamp::CharacterModelAnimation::animate(), Lamp::TextSceneLoader::readBone(), and Lamp::BinarySceneLoader::readBone().

The documentation for this class was generated from the following files:

- Bone.h
- Bone.cpp